mapMod = ...

mapMod:registerAssetId("maps/heightmap.png", MOD_NS .. "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", MOD_NS .. "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", MOD_NS .. "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", MOD_NS .. "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", MOD_NS .. "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", MOD_NS .. "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", MOD_NS .. "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/small_rocks_density.png", MOD_NS .. "SMALL_ROCKS_DENSITY_MAP")
mapMod:registerAssetId("maps/herbs_density.png", MOD_NS .. "HERBS_DENSITY_MAP")


local tallBeechScale = {
	Min = 0.8,
	Max = 1.2
}

local NATURE_NS = "JK_" 


local orientation = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					}

mapMod:registerAsset({
	DataType = "CUSTOM_MAP",
	Id = "JK_MAP_3_NAME",
	HeightMap =  MOD_NS .. "HEIGHT_MAP",
	MaterialMask = MOD_NS .. "MATERIAL_MASK",
	MinHeight = -17,
	MaxHeight = 140,
	VillagePathList = {
		{
			Entrance = {19, 20, 402},
			Exit = {19, 20, 402}
		},
		{
			Entrance = { 991, 41, 161},
			Exit = { 991, 41, 161}
		},
		{
			Entrance = { 23, 13, 917 },
			Exit = { 23, 13, 917 }
		},
		{
			Entrance = { 864, 18, 997},
			Exit = { 864, 18, 997}
		},
	},
	SpawnList = {
	},
	DensitySpawnList = {
		{
			DensityMap = MOD_NS .. "DECIDUOUS_DENSITY_MAP",
			Density = 0.4,
			PrefabConfigList = {
				{
					PrefabList = { NATURE_NS .. "PREFAB_OAK_A" },
					RandomWeight = 4,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.1
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_OAK_B" },
					RandomWeight = 0.5,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.1
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_OAK_C" },
					RandomWeight = 5,
					OffsetSizeRange = {
						Min = 0.7,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = tallBeechScale,
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_TREES_OAK_A" },
					RandomWeight = 0.5,
					OffsetSizeRange = {
						Min = 0.7,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = tallBeechScale,
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_SHRUB_A2" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 2
					},
					OrientationRange = {
						Min = { -5, -180, -5},
						Max = { 5, 180, 5}
					},
					ScaleRange = {
						Min = 1.1,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_BEECH_A" },
					RandomWeight = 4,
					OffsetSizeRange = {
						Min = 0.8,
						Max = 1.5
					},
					OrientationRange = {
						Min = { -2, -180, -2},
						Max = { 2, 180, 2}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.1
					},
					ColorRange = {
						Min = { 0.7, 0.7, 0.7, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_BEECH_B" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 0.8,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = tallBeechScale,
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}, {
					PrefabList = { NATURE_NS .. "PREFAB_BEECH_C" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 0.8,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = tallBeechScale,
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_BEECH_D" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 0.8,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = tallBeechScale,
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_BEECH_SAPLING_A" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 2
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_MAPLE_A" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.3
					},
					ColorRange = {
						Min = { 0.5, 0.5, 0.5, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_MAPLE_B" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.2
					},
					ColorRange = {
						Min = { 0.5, 0.5, 0.5, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_BIRCH_A" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.3
					},
					OrientationRange = {
						Min = { -5, -180, -5},
						Max = { 5, 180, 5}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_BIRCH_B" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.3
					},
					OrientationRange = {
						Min = { -5, -180, -5},
						Max = { 5, 180, 5}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_BIRCH_C" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.3
					},
					OrientationRange = {
						Min = { -5, -180, -5},
						Max = { 5, 180, 5}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			DensityMap = MOD_NS .."CONIFEROUS_DENSITY_MAP",
			Density = 0.4,
			PrefabConfigList = {
				{
					PrefabList = { NATURE_NS .. "PREFAB_FIR_A" },
					RandomWeight = 5,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 },
						LockValues = false
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_FIR_B" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 },
						LockValues = false
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_FIR_C" },
					RandomWeight = 7,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 },
						LockValues = false
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_PINE_A" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 1.0, 1.0, 1.0, 1 },
						LockValues = false
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_PINE_B" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.1
					},
					ColorRange = {
						Min = { 0.5, 0.5, 0.5, 1 },
						Max = { 1.0, 1.0, 1.0, 1 }
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_TREES_PINE_A" },
					RandomWeight = 1.4,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.05
					},
					ColorRange = {
						Min = { 0.5, 0.5, 0.5, 1 },
						Max = { 1.0, 1.0, 1.0, 1},
						LockValues = false
					}
				},
				{
					PrefabList = { NATURE_NS .. "PREFAB_PINE_C" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 0.9, 0.9, 0.9, 1 }
					}
				},
			}
		},
		{
			DensityMap = MOD_NS .. "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { NATURE_NS .. "PREFAB_BERRY_BUSH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = MOD_NS .."ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = MOD_NS .. "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			DensityMap = MOD_NS .. "SMALL_ROCKS_DENSITY_MAP",
			Density = 0.3,
			PrefabConfigList = {
				{
					PrefabList = {  MOD_NS .. "SMALL_ROCK_A_PREFAB",  MOD_NS .. "SMALL_ROCK_B_PREFAB",
						MOD_NS .. "SMALL_ROCK_C_PREFAB" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.3
					},
					OrientationRange = {
						Min = { -5, -180, -5},
						Max = { 5, 180, 5}
					},
					ScaleRange = {
						Min = 0.5,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
			}
		},
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = MOD_NS .. "SMALL_ROCKS_DENSITY_MAP",
			Density = 0.5,
			PrefabConfigList = {
				{
					PrefabList = { NATURE_NS .. "PREFAB_FLOWER_CHAMOMILE", NATURE_NS .. "PREFAB_FLOWER_CORNFLOWER", NATURE_NS .. "PREFAB_FLOWER_POPPIES",
								   NATURE_NS .. "PREFAB_MULLEIN", NATURE_NS .. "PREFAB_SHRUB_LAVENDER" },
					RandomWeight = 4,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 2
					},
					OrientationRange = {
						Min = { -5, -180, -5},
						Max = { 5, 180, 5}
					},
					ScaleRange = {
						Min = 1.0,
						Max = 1.1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
	}
})